.586
.model flat,stdcall
option casemap:none

WinMain PROTO   :DWORD,:DWORD,:DWORD,:DWORD
MakeMDIChild PROTO         :DWORD,:DWORD,:DWORD,:DWORD,:DWORD
CreateToolbar   PROTO   :DWORD

include c:\masm32\include\windows.inc
include c:\masm32\include\kernel32.inc
include c:\masm32\include\user32.inc
include c:\masm32\include\comctl32.inc
include c:\masm32\include\gdi32.inc


includelib c:\masm32\lib\kernel32.lib
includelib c:\masm32\lib\user32.lib
includelib c:\masm32\lib\comctl32.lib
includelib c:\masm32\lib\gdi32.lib


.const

MainWindowWidth        equ      800
MainWindowHeight        equ     400

ToolbarID               equ     0400h

.data
hInstance       DWORD           ?
CommandLine     LPSTR           ?

hMainWindow     dd              ?
MainWindowClass db              'MainWindowClass',0
MainWindowName  db              'MDI Child Example',0

; ++++ MDI related ++++ 

MDIClass        db      'MDICLIENT',0
hMdiClient      dd              ?
hMdi              dd              ?
lphMDI           dd             4 dup(?)
MdiName         db      'MDI Child Window ','?',0
MdiNumber       db      '1'
; ++++ Toolbar related ++++

ToolbarClass    db      'ToolbarWindow32',0
hToolbar          dd            ?
noTBButtons     dd            10
TBButtons       TBBUTTON        <0,0100h,TBSTATE_ENABLED,TBSTYLE_BUTTON,NULL,NULL>
                     TBBUTTON        <1,0101h,TBSTATE_ENABLED,TBSTYLE_BUTTON,NULL,NULL>
                     TBBUTTON        <2,0102h,TBSTATE_ENABLED,TBSTYLE_BUTTON,NULL,NULL>
                     TBBUTTON        <3,0103h,TBSTATE_ENABLED,TBSTYLE_BUTTON,NULL,NULL>
                     TBBUTTON        <4,0104h,TBSTATE_ENABLED,TBSTYLE_BUTTON,NULL,NULL>
                     TBBUTTON        <?,NULL,TBSTATE_ENABLED,TBSTYLE_SEP,NULL,NULL>
                     TBBUTTON        <5,0105h,TBSTATE_ENABLED,TBSTYLE_BUTTON,NULL,NULL>
                     TBBUTTON        <6,0106h,TBSTATE_ENABLED,TBSTYLE_BUTTON,NULL,NULL>
                     TBBUTTON        <?,NULL,TBSTATE_ENABLED,TBSTYLE_SEP,NULL,NULL>
                     TBBUTTON        <7,0107h,TBSTATE_ENABLED,TBSTYLE_BUTTON,NULL,NULL>

ButtonBitmaps   LABEL   DWORD
szTileHorz              db              '.\tilehorz.bmp',0
szTileVert              db              '.\tilevert.bmp',0
szCascade             db              '.\tilecasc.bmp',0
szIconArrange        db             '.\iconarng.bmp',0
szMdiRestore         db             '.\mdirest.bmp',0
szMdiPrev              db             '.\mdiprev.bmp',0
szMdiNext               db            '.\mdinext.bmp',0
szMdiClose             db             '.\mdiclose.bmp',0
  
; ++++ Other +++++

rect            RECT            <>
cc              CREATESTRUCT            <>

.code
        start:
                invoke  GetModuleHandle,NULL
                mov     hInstance,eax
                invoke  GetCommandLine
                mov     CommandLine,eax
                invoke  InitCommonControls
                invoke  WinMain,hInstance,NULL,CommandLine,SW_SHOWDEFAULT
                invoke  ExitProcess,eax

WinMain PROC    hInst:DWORD,hPrevInst:DWORD,CmdLine:DWORD,CmdShow:DWORD

        local   wc:WNDCLASSEX
        local   msg:MSG

        mov     wc.cbSize,sizeof wc
        mov     wc.style,CS_HREDRAW+CS_VREDRAW
        mov     wc.lpfnWndProc,offset WndProc
        mov     wc.lpszMenuName,NULL
        mov     wc.lpszClassName,offset MainWindowClass
        mov     wc.cbClsExtra,NULL
        mov     wc.cbWndExtra,NULL
        mov     wc.hbrBackground,COLOR_WINDOW
        push    hInst
        pop     wc.hInstance
        invoke  LoadIcon,NULL,IDI_APPLICATION
        mov     wc.hIcon,eax
        mov     wc.hIconSm,eax
        invoke  LoadCursor,NULL,IDC_ARROW
        mov     wc.hCursor,eax
        invoke  RegisterClassEx,addr wc
        invoke  GetSystemMetrics,SM_CYSCREEN
        shr     eax,1
        sub     eax,MainWindowHeight/2
        push    eax
        invoke  GetSystemMetrics,SM_CXSCREEN
        shr     eax,1
        sub     eax,MainWindowWidth/2
        pop     ebx
        invoke  CreateWindowEx,NULL,addr MainWindowClass,addr MainWindowName,WS_TILEDWINDOW,\
                eax,ebx,MainWindowWidth,MainWindowHeight,NULL,NULL,hInstance,NULL
        mov     hMainWindow,eax
        invoke  ShowWindow,eax,SW_SHOWNORMAL
        invoke  UpdateWindow,hMainWindow

        .while  TRUE

                invoke  GetMessage,addr msg,NULL,0,0

        .break .if (!eax)

                invoke  TranslateMessage,addr msg
                invoke  DispatchMessage,addr msg

        .endw

        mov     eax,msg.wParam
        ret

WinMain endp

WndProc PROC    hWnd:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD
        
        .if     uMsg==WM_DESTROY

                invoke  PostQuitMessage,NULL
        .elseif uMsg==WM_CREATE
                mov     edi,lParam
                .if     [edi.CREATESTRUCT].hWndParent==NULL
                        invoke  CreateToolbar,hWnd
                        invoke  GetClientRect,hToolbar,addr rect
                        mov     ebx,rect.bottom
                        add     ebx,3
                        invoke  GetClientRect,hWnd,addr rect
                        sub      rect.bottom,ebx
                        add     rect.top,ebx
                        invoke  CreateWindowEx,NULL,addr MDIClass,NULL,WS_VISIBLE+WS_CHILD+WS_CLIPCHILDREN,\
                                         0,rect.top,rect.right,rect.bottom,hWnd,NULL,hInstance,addr cc
                        mov     hMdiClient,eax
                        shr     rect.right,1
                        shr     rect.bottom,1
                        lea     esi,lphMDI
                        invoke  MakeMDIChild,hMdiClient,0,0,rect.right,rect.bottom
                        add     esi,4
                        inc     MdiNumber
                        invoke  MakeMDIChild,hMdiClient,rect.right,0,rect.right,rect.bottom
                        add     esi,4
                        inc     MdiNumber
                        invoke  MakeMDIChild,hMdiClient,0,rect.bottom,rect.right,rect.bottom
                        add     esi,4
                        inc     MdiNumber
                        invoke  MakeMDIChild,hMdiClient,rect.right,rect.bottom,rect.right,rect.bottom                        
                .endif    
        .elseif uMsg==WM_COMMAND
                mov     eax,wParam
                ror     eax,16
                .if     ax==BN_CLICKED
                        ror     eax,16
                        .if     ax==0100h
                                invoke  SendMessage,hMdiClient,WM_MDITILE,MDITILE_HORIZONTAL+MDITILE_SKIPDISABLED,NULL
                        .elseif ax==0101h
                                invoke  SendMessage,hMdiClient,WM_MDITILE,MDITILE_VERTICAL+MDITILE_SKIPDISABLED,NULL
                        .elseif ax==0102h
                                invoke  SendMessage,hMdiClient,WM_MDICASCADE,MDITILE_SKIPDISABLED,NULL
                        .elseif ax==0103h
                                invoke  SendMessage,hMdiClient,WM_MDIICONARRANGE,NULL,NULL
                        .elseif ax==0104h
                                invoke  SendMessage,hMdiClient,WM_MDIGETACTIVE,NULL,NULL
                                invoke  SendMessage,hMdiClient,WM_MDIRESTORE,eax,NULL
                        .elseif ax==0105h
                                invoke  SendMessage,hMdiClient,WM_MDIGETACTIVE,NULL,NULL
                                invoke  SendMessage,hMdiClient,WM_MDINEXT,eax,TRUE
                        .elseif ax==0106h
                                invoke  SendMessage,hMdiClient,WM_MDIGETACTIVE,NULL,NULL
                                invoke  SendMessage,hMdiClient,WM_MDINEXT,eax,NULL
                        .elseif ax==0107h                                
                                invoke  SendMessage,hMdiClient,WM_MDIGETACTIVE,NULL,NULL
                                invoke  SendMessage,hMdiClient,WM_MDIDESTROY,eax,NULL

                        .endif
                .endif                        
        .else

                invoke  DefWindowProc,hWnd,uMsg,wParam,lParam
                ret

        .endif

        xor     eax,eax
        ret

WndProc endp

CreateToolbar   PROC    hWnd:DWORD
        
        invoke  CreateWindowEx,WS_EX_CLIENTEDGE,addr ToolbarClass,NULL,WS_VISIBLE+WS_CHILD+TBSTYLE_ALTDRAG,\
                        0,0,0,0,hWnd,ToolbarID,hInstance,NULL
        mov     hToolbar,eax
        invoke  SendMessage,hToolbar,TB_BUTTONSTRUCTSIZE,sizeof TBBUTTON,NULL
        call    MakeImageList
        invoke  SendMessage,hToolbar,TB_ADDBUTTONS,noTBButtons,addr TBButtons
        invoke  SendMessage,hToolbar,TB_AUTOSIZE,NULL,NULL
        ret

CreateToolbar   endp

MakeImageList   PROC    

        local   hList:HWND
        local   hBmpTmp1:HWND
        local   hBmpTmp2:HWND
        
        invoke  ImageList_Create,30,30,ILC_COLOR16+ILC_MASK,7,7
        mov     hList,eax
        mov     ecx,noTBButtons
        lea      edi,ButtonBitmaps
loop_0:
        push    ecx
        invoke  LoadImage,NULL,edi,IMAGE_BITMAP,30,30,LR_LOADFROMFILE
        mov     hBmpTmp1,eax
        invoke  LoadImage,NULL,edi,IMAGE_BITMAP,30,30,LR_MONOCHROME+LR_LOADFROMFILE
        mov     hBmpTmp2,eax
        invoke  ImageList_Add,hList,hBmpTmp1,hBmpTmp2
        invoke  DeleteObject,hBmpTmp1
        invoke  DeleteObject,hBmpTmp2
loop_1:
        cmp     byte ptr [edi],0
        je        next_bmp
        inc     edi
        jmp     loop_1
next_bmp:
        pop     ecx
        inc     edi
        dec     ecx
        jcxz    end_loop_0
        jmp     loop_0
end_loop_0:
        invoke  SendMessage,hToolbar,TB_SETIMAGELIST,0,hList
        ret

MakeImageList   endp
                
.data

MDIChildClass   db      'MDIChildClass',0

.code

MakeMDIChild PROC  hWnd:DWORD,WndPosX:DWORD,WndPosY:DWORD,WndWidth:DWORD,WndHeight:DWORD

        local   wc:WNDCLASSEX

        mov     wc.cbSize,sizeof wc
        mov     wc.style,CS_VREDRAW+CS_HREDRAW
        mov     wc.lpfnWndProc,offset MdiProc
        mov     wc.cbClsExtra,NULL
        mov     wc.cbWndExtra,NULL
        mov     wc.lpszMenuName,NULL
        mov     wc.lpszClassName,offset MDIChildClass
        mov     wc.hbrBackground,COLOR_WINDOW+1
        push    hInstance
        pop     wc.hInstance
        invoke  LoadIcon,NULL,IDI_APPLICATION
        mov     wc.hIcon,eax
        mov     wc.hIconSm,eax
        invoke  LoadCursor,NULL,IDC_ARROW
        mov     wc.hCursor,eax
        invoke  RegisterClassEx,addr wc
        lea      edi,MdiName
        push    edi
loop_0:
        cmp     byte ptr [edi],0
        je        end_loop_0
        inc     edi
        jmp     loop_0
end_loop_0:        
        dec     edi
        mov     al,MdiNumber
        mov     byte ptr [edi],al        
        pop     edi
        invoke  CreateWindowEx,WS_EX_MDICHILD,addr MDIChildClass,edi,MDIS_ALLCHILDSTYLES,\
                        WndPosX,WndPosY,WndWidth,WndHeight,hWnd,NULL,hInstance,NULL
        mov     dword ptr [esi],eax                        
        invoke	ShowWindow,eax,SW_SHOWNORMAL
        ret                        
        
MakeMDIChild      endp

MdiProc PROC    hWnd:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

        .if     uMsg==WM_DESTROY
                invoke  SendMessage,hWnd,WM_MDIDESTROY,hWnd,NULL
        .else
                invoke  DefMDIChildProc,hWnd,uMsg,wParam,lParam
                ret
        .endif

ret

MdiProc endp
                                  
end     start                                       